#region - Alcohol 120% Trial Version 1.9.5.4521 install script - (Automated with WinExists functions)

Opt('TrayIconDebug', 1)

; Installer.
$executable = 'Alcohol120_trial_1.9.5.4521.exe'

; Show progess.
$splash = 0

; Default catagory folder in startmenu.
$group = 'Burning software'

; New catagory to move the default folder into.
$catagory = ''

; Installation folder in Program Files.
$directory = 'Alcohol 120'

; Allowed time for installation.
$allowed = 300 * 1000

; The next setting should be 0 unless you want to reboot imediately.
; Auto or manual reboot. (either choice will runonce the installer at next reboot).
$auto_reboot = 0

; The next setting is not used if $auto_reboot = 1.
; Desktop Reboot. (Set to 1 if you want the script to handle the reboot into the 2nd part of install)
$desktop_reboot = 0

; ** README ""
; Check values above and "Remove shortcuts" section below are correct.
; This is a 2 part install. The 2nd part automatically happens on reboot at HKCU\RunOnce
;   which is when the Startup folder is processed and the Desktop is active. This script
;   is set to manage both parts of installation automagically.
; Spyware is unchecked for installation. ;)

; Main Window Titles.
$title_alcohol = 'Alcohol 120% Trial Version 1.9.5.4521'
$title_sptd   = 'SPTD setup V1.29'

; Run the installer.
If $auto_reboot And StringInStr($cmdlineraw, '/postrun') Then
    If WinWait($title_alcohol, 'Welcome to the Alcohol', 30) Then
        $pid = $executable
    Else
        $pid = _Install()
    EndIf
Else
    $pid = _Install()
EndIf

$time = TimerInit()
Do
    Select ; 1st 3 windows are messageboxes.
        Case WinExists($title_sptd, 'This program will install SCSI Pass Through Direct')
            Sleep(1000)
            ControlClick($title_sptd, 'This program will install SCSI Pass Through Direct', 'Button1')
            WinWaitClose($title_sptd, 'This program will install SCSI Pass Through Direct', 10)
            WinWait($title_alcohol, 'Setup must restart Windows', 5)

        Case WinExists($title_alcohol, 'Setup must restart Windows')
            _RunOnce()
            If $auto_reboot Then
                $choice = 'Button1'
            Else
                $choice = 'Button2'
            EndIf
            ControlClick($title_alcohol, 'Setup must restart Windows', $choice)
            WinWaitClose($title_alcohol, 'Setup must restart Windows', 5)
            Exit

        Case WinExists($title_alcohol, 'You must reboot after previous operation')
            _RunOnce()
            ControlClick($title_alcohol, 'You must reboot after previous operation', 'Button1')
            ; Desktop Reboot after 20 seconds if set above.
            If $desktop_reboot Then
                Sleep(15*1000)
                MsgBox(262144, $title_alcohol, 'System restart commencing now', 5)
                Shutdown(2)
            EndIf
            Exit

        Case WinExists($title_alcohol, 'Welcome to the Alcohol')
            ControlClick($title_alcohol, 'Welcome to the Alcohol', 'Button2')

        Case WinExists($title_alcohol, 'License Agreement')
            If WinWait($title_sptd, 'This program will install SCSI Pass Through Direct', 2) Then
                ContinueLoop
            EndIf
            ControlClick($title_alcohol, 'License Agreement', 'Button2')
           
        Case WinExists($title_alcohol, 'Already Installed')
            $text = 'Update the automated installation script for uninstall or upgrade support'
            MsgBox(262144, $title_alcohol, $text, 5)
            _Abort()

        Case WinExists('Alcohol Soft Setup', 'Additional Features')
            ControlCommand('Alcohol Soft Setup', 'Additional Features', 'Button1', 'UnCheck', '')
            ControlClick('Alcohol Soft Setup', 'Additional Features', 'Button2')

        Case WinExists($title_alcohol, 'Choose Components')
            ControlClick($title_alcohol, 'Choose Components', 'Button2')

        Case WinExists($title_alcohol, 'Choose Install Location')
            ControlSend($title_alcohol, 'Choose the folder', 'Edit1', @ProgramFilesDir & '\' & $directory)
            ControlClick($title_alcohol, 'Choose the folder', 'Button2')

        Case WinExists($title_alcohol, 'Completing the Alcohol')
            ControlCommand($title_alcohol, 'Completing the Alcohol', 'Button4', 'UnCheck', '')
            ControlClick($title_alcohol, 'Completing the Alcohol', 'Button2')
            ExitLoop
    EndSelect
    Sleep(1000)
    If TimerDiff($time) > $allowed Then _Abort()
Until Not ProcessExists($pid)

; Remove shortcuts.
If _MainShortcut('Alcohol 120%.lnk') Then
    FileDelete('Uninstall.lnk')
    _Desktop('Alcohol 120%.lnk')
EndIf


#endregion

Exit

Func _Install($path = 'Default')
    ; Run the installer in Default Script directory.
    Dim $splash, $processblock
    If $path = 'Default' Then $path = @ScriptDir
    If StringRight($path, 1) <> '\' Then $path = $path & '\'
    If StringInStr($executable, '\') Then $path = ''
    If Not FileExists($path & $executable) Then Exit(1)
    If $processblock <> '' Then Call('_' & 'ProcessBlock')
    If $splash Then _Splash('Installing:' & StringTrimRight(StringReplace(@ScriptName, '_', ' '), 4))
    If StringRight($executable, 3) = 'msi' Then
        Return Run(@SystemDir & '\msiexec /i "' & $path & $executable & '"')
    Else
        Return Run($path & $executable)
    EndIf
EndFunc

Func _Abort()
    ; close process if exists then exit.
    Dim $pid
    If ProcessExists($pid) Then
        ProcessClose($pid)
        Exit(2)
    Else
        Exit(3)
    EndIf
EndFunc

Func _Desktop($shortcut)
    ; Delete a Desktop shortcut.
    If FileExists(@DesktopDir & '\' & $shortcut) Then
        Return FileChangeDir(@DesktopDir) And FileDelete($shortcut)
    ElseIf FileExists(@DesktopCommonDir & '\' & $shortcut) Then
        Return FileChangeDir(@DesktopCommonDir) And FileDelete($shortcut)
    EndIf
EndFunc

Func _MainShortcut($shortcut, $rename = '')
    ; Change working directory to correct StartMenu\Group directory.
    Dim $group, $catagory, $splash
    If $group = '' Then Return 0
    If FileExists(@ProgramsDir & '\' & $group) Then
        FileChangeDir(@ProgramsDir & '\' & $group)
    ElseIf FileExists(@ProgramsCommonDir & '\' & $group) Then
        FileChangeDir(@ProgramsCommonDir & '\' & $group)
    Else
        Return 0
    EndIf
    ; Wait for main shortcut.
    If $splash Then _Splash('Waiting for shortcuts')
    For $i = 1 To 20
        If FileExists($shortcut) Then ExitLoop
        Sleep(500)
    Next
    If $splash Then _Splash('Cleaning up:' & StringTrimRight(StringReplace(@ScriptName, '_', ' '), 4))
    ; If catagory not assigned anything, then return.
    If $catagory = '' Then Return 1
    ; Move the group folder into the catagory folder.
    If FileChangeDir('..') And DirCopy($group, $catagory & '\' & $group, 1) Then
        If DirRemove($group, 1) Then
            ; If optional rename parameter is used, then rename the group folder.
            If $rename <> '' And FileChangeDir($catagory) Then
                If DirCopy($group, $rename, 1) And DirRemove($group, 1) Then
                    Return FileChangeDir($rename)
                EndIf
            Else
                Return FileChangeDir($catagory & '\' & $group)
            EndIf
        EndIf
    EndIf
EndFunc

Func _QuickLaunch($shortcut)
    ; Delete a Quicklaunch shortcut.
    Local $subdirs = '\Microsoft\Internet Explorer\Quick Launch'
    If FileExists(@AppDataDir & $subdirs & '\' & $shortcut) Then
        Return FileChangeDir(@AppDataDir & $subdirs) And FileDelete($shortcut)
    ElseIf FileExists(@AppDataCommonDir & $subdirs & '\' & $shortcut) Then
        Return FileChangeDir(@AppDataCommonDir & $subdirs) And FileDelete($shortcut)
    EndIf
EndFunc

Func _Splash($text = '')
    ; Shows a small borderless splash message.
    Dim $splash
    If $splash Then
        If $text Then
            SplashTextOn('', $text, 500, 25, -1, 5, 1, '', 14)
        Else
            SplashOff()
        EndIf
    EndIf
EndFunc

Func _WinClose($title, $text = '')
    ; Close a window with further attempts.
    For $i = 1 To 10
        WinClose($title, $text)
        If Not WinExists($title) Then Return 1
        Sleep(500)
    Next
EndFunc

Func OnAutoItStart()
    ; A 2nd script instance will exit.
    Local $interpreter
    If StringInStr($cmdlineraw, '/dummy') Then Exit
    $interpreter = StringTrimRight(@ScriptName, 4) & ' Script Interpreter'
    If WinExists($interpreter) Then Exit
    AutoItWinSetTitle($interpreter)
EndFunc

Func _RunOnce()
    ; Add 2nd part to installation.
    Local $key = 'HKCU\Software\Microsoft\Windows\CurrentVersion\RunOnce'
    If @Compiled Then
        RegWrite($key, '_Alcohol', 'Reg_sz', '"' & @ScriptFullPath & '" /postrun')
    Else
        RegWrite($key, '_Alcohol', 'Reg_sz', '"' & @AutoItExe & '" "' & @ScriptFullPath & '" /postrun')
    EndIf
EndFunc 